// This is a JavaScript module that is loaded on demand. It can export any number of
// functions, and may import other JavaScript modules if required.

export async function init(dotNetObject, element, sitekeyValue) {

    var tag = document.createElement("div");
    element.innerHTML = '';
    element.appendChild(tag);

    const grecaptchaRender = () => {
        return new Promise((resolve, reject) => {

            let intervalCounter = 0;
            let intervalTimeout = setInterval(() => {

                // If is not undefined
                if (!(typeof grecaptcha == 'undefined')) {
                    
                    clearInterval(intervalTimeout);

                    grecaptcha.ready(() => {
                        
                        let result = grecaptcha.render(tag, {
                            'sitekey': sitekeyValue,
                            'callback': (response) => { dotNetObject.invokeMethodAsync('CallbackOnSuccess', response); },
                            'expired-callback': () => { dotNetObject.invokeMethodAsync('CallbackOnExpired', response); }
                        });
                        resolve(result);
                    });
                }

                intervalCounter++;
                if (intervalCounter > 20) {
                    clearInterval(intervalTimeout);
                    console.error('Google Recaptcha script is missing. Please add it in index.html:', '<script src="https://www.google.com/recaptcha/api.js"></script>');
                    reject('Google Recaptcha script is missing');
                }

            }, 50);
        });
    };

    return await grecaptchaRender();
};

export function getResponse(response) {
    return grecaptcha.getResponse(response);
} 